#|
   module      : directed
   owner       : Franz Weber
   author      : Franz Weber
   explanation : 
   
	This ADT implements directed graphs in the sense of simple
	trees. This means, that the nodes of the graph are simple
	aggregates. A graph is simply seen as a set of such node
	objects. Special support is given for the iteration over
	reachable objects. Consistency is not garanteed, when deleting
	nodes from the graph (dangling references).

	(defflavor directed-graph () (unordered))

|#
