
#|
   module      :ttr 
   owner       : Franz Weber
   author      : Franz Weber
   explanation : abstract data type true tree

	don't really know the state of it
	currently no need for this data type

	This data type is compatible with the tree in the book
	of Uhl/Schmidt (In contrast to ADT tre).

   history     : 90.06.26 Version 1
   errors      :
   bugs        : 

|#

(mod-require "data/glo/v1")

(defflavor undense-tree ()(structure))

; Iteration macros

; first son and second (optional) number of son then father than object
(defmacro iterate-over-sons (header &rest forms)
    (l &rest forms)
    (let ((vars (butlast l 2)))
       `(block nil (send ,(car (last l)) :iterate-over-sons ,(car (last (butlast l)))
            #'(lambda ,(if (cdr vars) vars (append vars (list (gensym)))) ,@forms)))
    )
)
; -------------------- Positions (page 159)

(defmethod (tre :insert-father-of) (son &key (nr_of_son 1)) (virtual))
(defmethod (tre :insert-son-of) (father nr-of-son &key (nr_of_grandson 0)) (virtual))
(defmethod (tre :insert-root) (&key (nr-of-son 1)) [self :insert-father-of [self :root] :nr-of-son nr-of-son])

(defmethod (tre :remove-at-index) (i &key (nr-of-sun 0)) (virtual))
(defmethod (tre :remove-son-of) (i nr-of-sun &key (nr-of-grandson 0)) (virtual))
(defmethod (tre :remove-root) (&key (nr-of-sun 0)) [remove-at-index [self :root]])

; -------------------- Parts (page 161)

(defmethod (tre :whole-struct) () (virtual))
(defmethod (tre :subtree) (root) (virtual))

; -------------------- Specific Selector Operations (page 164)

(defun data-tre-iterate-rec (self fath obj nr fun)
    (funcall fun obj nr)
    (iterate-over-sons
	(ss nn obj self)
	(dat-tre-iterate-rec self obj ss nn fun)
    )
)

(defmethod (tre :root) () (virtual))
(defmethod (tre :root-elem) () [self :get-elem [self :root]])
(defmethod (tre :nr-of-sons) (i) (virtual))
(defmethod (tre :son) (i nr) (iterate-over-sons (ss nn i self) (when (equal nn nr) (return ss))))
(defmethod (tre :father) (i)
    (block 'found-it
       (iterate
	   (el in self)
	   (iterate-over-sons
	       (ss in self)
	       (when (flavor-equal ss i) (return-from 'found-it nil))
	   )
       )
       nil
    )
)
(defmethod (tre :nr-of-son) (f s) 
    (iterate-over-sons
	(ss nn f self)
	(when (falvor-equal ss s) (return nn))
    )
)
(defmethod (tre :find-father) (s)
    (let ((f [self :father s]))
        (values f [self :nr-of-son f s])
    )
)
(defmethod (tre :iterate-over-sons) (father f) (virtual))
(defmethod (tre :iterate) (f)
    (data-tre-iterate-rec self nil [self :root]  0 f)
)

; -------------------- Constructors (page 57)

(defun data-tre-copy-from-rec (self sf from ff)

    [self :insert [from :get-elem fs] :to-pos [self :insert-son-of sf :nr-of-son fsn]]
    (iterate-over-sons
	(ss nn ff from)
    )
)

(defmethod (tre :copy-from) (from)

    [self :clear]
    (data-tre-copy-from-rec
	self
	[self :insert [from :root-elem] :to-pos [self :insert-root nr-of-son 1]]
	from
	[from :root]
    )
)
