; Just write 'our-disksave' instead of 'disksave'

(defun our-disksave (target-file
		     &key restart-function
			  full-gc
			  gc
			  (reserved-free-segments 2)
			  (dynamic-free-segments 0)
			  verbose
                    )

    (defadvice (member disksave-bug) (first second &rest args)
	(unless (listp second) (setq second (list first)))
	(apply-advice-continue first second args)
    )
    (disksave
	target-file
	:restart-function
	    #'(lambda ()
		  (remove-advice 'member 'disksave-bug)
		  (when restart-function (funcall restart-function))
	      )
	:gc gc
	:full-gc full-gc
	:reserved-free-segments reserved-free-segments
	:dynamic-free-segments dynamic-free-segments
    )
    (remove-advice 'member 'disksave-bug)
)
