#|
   module      : component
   owner       : Franz Weber
   author      : Franz Weber
   explanation : components

	maintains a father pointer for the object by an instance variable

	serves for hierarchical structures, in which information shall be propagated upwards.

   history     : 90.06.26 Version 1
   errors      :
   bugs        : clear same file in version 2 of tree !!
|#

(defflavor component (father)() 
    (:settable-instance-variables father)
    (:gettable-instance-variables father)
    (:init-keywords :father)
)

