#|
   module      : simple lin
   owner       : Franz Weber
   author      : Franz Weber
   explanation : 

	Instanciation of 'generic linear aggregate' and 'simple
	aggregate'

	This is useful for records e.g.
	(Data Structure with a fixed order on components, which are
	not set- or list-like)

   history     : 90.06.26
   errors      :
   bugs        :
|#

(mod-require "data/glo/v2/simple-aggregate")
(mod-require "data/glo/v2/lin-gen")
(defflavor simple-linear-aggregate () (generic-linear-aggregate simple-aggregate))
