#|
   module      : lis-lazy.test
   owner       : Peter Sanders
   author      : Peter Sanders
   explanation : some simple tests for lazy-lists
   history     : 91.3.4 Version 1
   errors      :
   bugs        : because of the limited functional power of lazy-lists it was 
                 not possible to follow the usual  testing scheme from 
                 aggregates.test.lisp
|#

(mod-require "data/lis/v2/lis-lazy")


(defun numbers (a) (lazy-cons a (numbers (1+ a))))
(setq nats (make-instance 'lis-lazy :init-value (numbers 1)))

(print "First element")(princ [nats :first])
(print "Rest")(princ [nats :next [nats :first]])
(print "Suche nach der 1000")
(princ [nats :find 1000] )
(setq small-primes 
      (make-instance 'lis-lazy :init-value
		     (lazy-cons 2 (lazy-cons 3 (lazy-cons 5 (lazy-cons 7 nil))))))

(print "Maximum:")(princ [small-primes :max])



