#|
   module      : lis-test
   owner       : Franz Weber
   author      : Franz Weber
   explanation : abstract data type setping implemented as test table
   history     : 90.06.26 Version 1
   errors      :
   bugs        :
|#

(mod-require "data/lis/v2/lis")
(mod-require "data/glo/v2/lin.test")

(defflavor lis-test () (lis linear-aggregate-test))

(defmethod (lis-test :test-index-of) (any lof)
    [:insert any]
    (flavor-equal [:get-elem [:index-of `(at-index ,[:find any])]] any)
)

(defmethod (lis-test :generate-any) () 1)
(defmethod (lis-test :generate-lof) () (list 1 2 3))
(defmethod (lis-test :generate-objects) ()
    (list
	(make-instance (type-of self) :init-value '())
	(make-instance (type-of self) :init-value '(1 2 3 4))
	(make-instance (type-of self) :init-value '(1))
	(make-instance (type-of self) :init-value '(1 2 7 8))
    )
)
