#|
   module      : map-test
   owner       : Franz Weber
   author      : Franz Weber
   explanation : abstract data type setping implemented as test table
   history     : 90.06.26 Version 1
   errors      :
   bugs        :
|#

(mod-require "set/v2/set.test")
(mod-require "glo/v2/key.test")
(mod-require "map/v2/map")

(defflavor map-test () (map set-test key-aggregate-test))

(defmethod (map-test :generate-any) () '(1 2))
(defmethod (map-test :generate-lof) () '((1 3) (2 7) (3 8)))
(defmethod (map-test :generate-objects) ()
    (list
	(make-instance (type-of self) :init-value '())
	(make-instance (type-of self) :init-value '((1 1) (2 4) (3 7) (4 9)))
	(make-instance (type-of self) :init-value '((1 8)))
	(make-instance (type-of self) :init-value '((1 2) (2 8) (7 1) (8 19)))
    )
)
