#|
   module      : stack
   owner       : Franz Weber
   author      : Franz Weber
   explanation : 

	ADT stack
	derived from ADT lis

	A lot of methods should be hidden from list. This is not done
	up to now. There are the following stack specific methods:

	(defmethod (stack :push) (e) [:insert e :to-pos 'first])
	(defmethod (stack :pop) () [:remove 'first])
        (defmethod (stack :top) () [:get-elem [:first]])

   history     : 90.06.26 Version 1
   errors      :
   bugs        :
|#

(mod-require "data/lis/v2")

(defflavor stack () (lis))

(defmethod (stack :push) (e) [:insert e :to-pos 'first])
(defmethod (stack :pop) () [:remove 'first])
(defmethod (stack :top) () [:get-elem [:first]])

; note that many operations are forbidden for stacks
