 #|
   module      : flavor-test
   owner       : Franz Weber
   author      : Franz Weber
   explanation : test flavor conventions
   history     :
  
	90.07.24 
  
   bugs        :
   errors      :
|# 

(defun fla-dump (e)
    (if (type-p 'structure e)
	[e :dump]
	(format t "~a~%" e)
    )
)

(defmacro fla-trace (class method)
    (eval `(defwhapper
	       (,class ,method) (&rest args)
	       (format t "before call of ~a in ~a~%" method class)
	       (mapc 'fla-dump args)
	       (let ((erg (multiple-value-list (continue-whopper-all))))
		   (format t "after call of ~a in ~a~%" method class)
		   (mapc 'fla-dump erg)
	       )
	   )
    )
)
